#!/usr/bin/perl -w
use strict;
#use lib qw ( @@ LIBDIR@@ );
use lib qw ( /usr/share/perl5/vendor_perl/ );
# my $kas=/"/";

use RRDs;
use CGI qw (:standard);
use CGI::Carp qw (fatalsToBrowser croak );
use Plugins;
use Misc;
use Misc qw ( OpenUserConfig SaveUserConfig SetLang Initialize_configs );

use Sys::Hostname;
use POSIX qw( mktime strftime );
$ENV{'PATH'} = '/bin:/usr/bin:/sbin:/usr/sbin';

Initialize_configs () if (exists ($ENV{'MOD_PERL'})); #check and reinitialize config files for mod_perl

#limit size data form
$CGI::POST_MAX = 2000;
$CGI::DISABLE_UPLOADS = 1;

#use Misc qw ( %config $int_collected );
use vars qw ( %Tags );  #table ob tags

my $DefaultTemplate = "main.html";
my $charset = $dict {'CHARSET'}; #use correct charset

my $Page = "system";
#names of periods
my %perioddesc = ('1h',$dict{'LASTHOUR'},
		'6h',$dict{'LAST6HOUR'},
		'1d',$dict{'LASTDAY'},
		'1w',$dict{'LASTWEEK'},
		'1m',$dict{'LASTMONTH'});

$Tags {'PNG_URL'} = $sysconfig  {'PNG_URL'};
$Tags {'PNG_DIR'} = $sysconfig {'PNG_DIR'};
$Tags {'ICONS'} = $sysconfig {'ICONS'};
$Tags {'IMG'} = $tempconfig {'IMG'};
$Tags {'LANG_IMG'} = $tempconfig {'LANG_IMG'};
$Tags {'EDIT_URL'} = $sysconfig {'EDIT_URL'};
$Tags {'DOC_URL'} = $tempconfig {'DOC'};
$Tags {'DOC_ROOT'} = $sysconfig {'DOC_URL'};

#detect hostname
if (defined ($sysconfig {'HOSTNAME'})) {
 $Tags {'HOSTNAME'} =$sysconfig {'HOSTNAME'};
} else {
 $Tags {'HOSTNAME'} = hostname ();
}

#test if live is locked
my $live_locked = $userconfig {'LOCK_LIVE'};
$live_locked = 0 if (! defined ($live_locked));
$tempconfig {'LIVE_LOCKED' } = $live_locked;

#test if more info is locked
my $more_info = $userconfig {'MORE_INFO'};
$more_info = 0 if (! defined ($more_info));
$tempconfig {'SHOW_MORE_INFO' } = $more_info;


$tempconfig {'SCRIPT_URL' } = "./".url (-relative=>1);   #save script URL

$Tags {'SCRIPT_URL' } = $tempconfig {'SCRIPT_URL' };
my $scripturl2 = self_url ();
$Tags {'SELF_URL'} =$scripturl2;
$tempconfig {'SELF_URL'} =$scripturl2;

#clean old image files
  if (int (rand 50) == 1) {
  use File::stat;
   my $PNGDir=$sysconfig{'STAT_PNG_DIR'};
   if (opendir (DIR, "$PNGDir")) {
   my @files = grep {/\.png$/} readdir DIR;
   closedir DIR;
   foreach my $f (@files) {
   $f = $PNGDir.$f;
  my $mtime = stat ($f) ->mtime if ( -e $f);
  if ( defined ($mtime)) {
  my $diff = time -$mtime;
  unlink ($f) if ($diff > 180); # 3 min
  }
  }
 }
}

#default presentation period
my $from="1d";
my $to='now';
#read data form
if (url_param ('from')) {
$from =url_param ('from');
};
if (url_param ('to')) {
$to =url_param ('to');
};

if (param ('page')) {
$Page =param ('page');
croak "Invalid page name: $Page" if (!($Page =~ /^\w+$/));
};




if (param ('RESULT')) {
 if (param ('RESULT') eq 'OK_DATE') {
 #process data form form change period
 $from = mktime (0,0,0, param ('from_day'), param ('from_month') -1 , param ('from_year') -1900);
 $to = mktime (59,59,23, param ('to_day'), param ('to_month') -1 , param ('to_year') -1900);
 if ($from > $to ) {
   $Tags {'ERROR'} = 'Invalid date: TO_DATE must be greater or equal to FROM_DATE.';
  print header(-expires=>'now',-charset=>$charset);
  Gen (\%Tags,'error.html',1);
  exit;
  }
 }

 #select language
 if (param ('SET_LANG')) {
  if (! defined ($userconfig{'LANG'})) {
   my $lang = param ('RESULT');
   #test lang string
   croak "Invalid language name: $lang, contact with system administrator!\n"    if ( ($lang =~ /\W/i) || (length ($lang) > 6));
   $userconfig{'LANG'} = $lang;
   my %userconfig2;
   OpenUserConfig (\%userconfig2); #open user config
    if (IF_DEMO ()) {
    $DefaultTemplate = 'demo.html';
   } else {
   $userconfig2{'LANG'} = $lang;

  #save LANG info
     SaveUserConfig (\%userconfig2);
     print header(-Refresh=>"0; URL=$tempconfig{'SCRIPT_URL'}",-expires=>'now',-charset=>$charset);
     print start_html(''),
     	end_html;
     exit;

  } #end NO demo
  }
 }
}

#detect language
if (! defined ($userconfig{'LANG'})) {
 $DefaultTemplate = "sellang.html";
 print header(-expires=>'now',-charset=>$charset);
 #generate HTML page from template
 Gen (\%Tags,$DefaultTemplate,1);
 exit
}

#test lock
if ( -e $sysconfig {'LSTAT_LCK'}) {
 $Tags{'LOCK_FILE'} = $sysconfig {'LSTAT_LCK'};
 $DefaultTemplate = "locked.html";
 print header(-expires=>'now',-charset=>$charset);
 #generate HTML page from template
 Gen (\%Tags,$DefaultTemplate,1);
 exit
}

#sub for pageprocess
if ($from eq  "any") {
 #generate page for choice period
$Tags {'PG'} = sub  {
  my $TagsRef = shift;
  my $today = time;
#  my $yesterday = $today - (24*60*60);

 # my @mytime = localtime $yesterday;
  my @mytime = localtime $today;   
  my @mytime2= localtime $today;

 $TagsRef ->{'FROM_DATE1'} =  [popup_menu (-name=>'from_year',-values=>[$mytime[5]+1900-2..$mytime[5]+1900],-default=>$mytime[5]+1900) ];
 $TagsRef ->{'FROM_DATE2'} = [popup_menu (-name=>'from_month',-values=>[1..12],-default=>$mytime[4]+1)];
 $TagsRef ->{'FROM_DATE3'} = [popup_menu (-name=>'from_day',-values=>[1..31],-default=>$mytime[3])];
 $TagsRef ->{'TO_DATE1'} = [popup_menu (-name=>'to_year',-values=>[$mytime2[5]+1900-2..$mytime2[5]+1900],-default=>$mytime2[5]+1900)];
 $TagsRef ->{'TO_DATE2'} = [popup_menu (-name=>'to_month',-values=>[1..12],-default=>$mytime2[4]+1)];
 $TagsRef ->{'TO_DATE3'} = [popup_menu (-name=>'to_day',-values=>[1..31],-default=>$mytime2[3])];
  $TagsRef ->{'page'} = $Page;
		Gen ($TagsRef, "anyperiod.html",1);
	            }	;

}
else {
#default for all pages
$Tags {'PG'} = sub  {
                         my $TagsRef = shift;
		Gen ($TagsRef, $Page);
	            }	;
}

#set periodinfo
if ($from =~ /^\d+$/) {
 #only numeric
 my $dateformat = $userconfig {'DATEF'}; #date format
 my $periodinfo = $dict{'FROM'}." ";
 $periodinfo .= strftime ($dateformat, localtime($from));
 $periodinfo .= " $dict{'TO'} ";
 if ( $to eq "now" ) {
  $periodinfo .= strftime ($dateformat, localtime);
   } else {
  $periodinfo .=  strftime ($dateformat, localtime($to));
  }
 $Tags {'PERIOD_INFO'} = $periodinfo;
} else {
 if (defined ($perioddesc {$from})) {
  $Tags {'PERIOD_INFO'} = $perioddesc {$from};
  } else {$Tags {'PERIOD_INFO'} = ''}
}

$Tags {'TIME'} = strftime ($userconfig{'DATETF'}, localtime); #store date and time of generating page

if (url_param ('template')) {
$DefaultTemplate =url_param ('template');
};

my $refresh = 1;
if (param ('refresh')) {
$refresh =param ('refresh');
};

$Tags {'PAGE'} = $Page;
$Tags {'FROM'} = $from;
$Tags {'TO'} = $to;


my $Privobjname;
my $objid;
my $up = $userconfig {'LIVE_PERIOD'};

if (param ('obj')) {
#stats only for one objects
$Privobjname = param ('obj');
$Tags {'OBJ_NAME'} = $Privobjname;
}

if (param ('format')) {
 #change language
 if (param ('LANG')) {
  my $lang=param ('LANG');
  SetLang ($lang);
 }
 #new format of data
 my $format=param ('format');
 #get all params
 my @ParamNames = param();
 my $paramline ='';
 foreach my $key (@ParamNames) {
  my $value = param ($key);
  $paramline .= "\&".$key.'='.$value;
 }

      my $objname = $1;
     my $obj;
      $obj = LoadObjectByName ($Privobjname); # load object to memory
      if (! defined ($obj)) { croak "Can't load object: $Privobjname \n" }
     $obj->Draw ($from, $to,$format,$paramline); #draw obj graph
     undef $obj;
     exit;

}

if (param ('la')) {

 #live action, after start or stop
 $_ = param ('la');
 $refresh = 1 if (/start/);  # start automatic refresh
 $refresh = 0 if (/stop/);  # stop automatic refresh
 if (/close/) {
  SendMsg (1, param ('id')) ; #destroy object;
  print header(), start_html (-title=>'Close This Window',-onLoad=>'javascript: void window.close()'), end_html();
  #$DefaultTemplate ="closelive.html";
  exit;
  }

 }

my $action='';
$action = param ('action') if (defined (param ('action')));

if ($action eq 'info') { #additional info
    print header(-expires=>'now',-charset=>$charset);
    $Tags {'OBJ_INFO'} = sub {
       #show data in table
      my $obj;
      if (defined ($Privobjname)) {
        #stadard object
        $obj = LoadObjectByName ($Privobjname); # load object to memory
       } else {
        #tempolary object
        $obj = LoadObjectByName ($objid);
       }

      if (! defined ($obj)) { croak "Can't load object: $Privobjname \n" }
     if (($obj->{'HAS_INFO'}) and $more_info) {
      $obj->Info (); #show addtional info
     }
   undef $obj;
 };

    Gen (\%Tags,"objinfo.html",1);
    exit;
 } #end info

 else
 {
 if ($action eq 'live') {
 #test if LIVE are locked
 if ( $live_locked) {
  croak ("LIVE graphs are locked.");
 } else {
 #start new object for live
 my $obj = LoadObjectByName ($Privobjname); # load object to memory
 if (! defined ($obj)) { croak "Can't load object: $Privobjname \n" }
 #find name for temp object
 my $newname;
 do {
  $objid = int (rand 100000);
  $newname = $sysconfig {'OBJ_DIR' }.$objid.'.obj';
   } while (-e $newname );
 $obj->name ($objid); #set newname
 $obj->UpdatePeriod ($up); #set new update period
 $obj->SaveToFile ($newname); #copy object
 undef $obj;
 my $err;
 if (! ($err = SendMsg (0, $objid)) ) { #send message fo daemon to create rrd file;
 #param (-name=>'id', -value=>$objid);
 $DefaultTemplate ="live.html";

 #refresh to new template
 my $scripturl3=$tempconfig {'SCRIPT_URL' };
 $refresh = $userconfig {'LIVE_REFRESH' }; #if start automatic refresh
 } else {
  #problems with SendMsg
  $Tags {'ERROR'} = $err;
  $DefaultTemplate ="error.html";
 }
}
} #end live


#print HTML header
if (url_param ('id') || ($action eq 'live')) {
  $objid = url_param ('id') if ($action ne 'live');
  my $scripturl3=$tempconfig {'SCRIPT_URL' };
  #filtered url without la param
  my $liveurl = "$scripturl3?id=$objid&from=-600&template=live.html&refresh=$refresh";
  $Tags {'LIVE_URL'} = $liveurl;
  $Tags {'LIVETABLE_URL'} = "$scripturl3?id=$objid&from=-600&template=table.html"; #for show table for live object
  $Tags {'OBJ_NAME'} = $objid;

  #sub for show live data in table
  $Tags {'ID'} = sub {
#     $objid = url_param ('id'); #get object id
#     $objid = param ('id'); #get object id
#     my $objfile = $config {'TEMP_DIR' }.$objid.'.obj';
     my $obj = LoadObjectByName ($objid);
      if (! defined ($obj)) { croak "Can't load object: $objid\n" }
      $obj->Draw ($from, $to, "nomenu"); #draw obj data
      undef $obj;
  };


 if ($refresh && ($DefaultTemplate eq 'live.html')) { #refresh only for Live objects
  print header(-Refresh=>"$up; URL=$liveurl",-expires=>'now',-charset=>$charset);
  } else {
  #header without automatic refresh
  print header(-expires=>'now',-charset=>$charset);
  }
} else
{ #print header(-Refresh=>"300; URL=$scripturl2",-expires=>'+20s');
 print header (-charset=>$charset,-expires=>'now');
 }
} #end live process

 #save this code to tags
$Tags {'TABLE'} = sub {
      #show data in table
      my $obj;
      if (defined ($Privobjname)) {
        #stadard object
        $obj = LoadObjectByName ($Privobjname); # load object to memory
       } else {
        #tempolary object
        $obj = LoadObjectByName ($objid);
       }

      if (! defined ($obj)) { croak "Can't load object: $Privobjname \n" }
      $obj->ShowData ($from, $to); #show table with data
      undef $obj;
};

$Tags {'DRAW'} = sub {
     my $paramline = shift;
     $paramline =~ s/^(\w+)//; #extract objname
     my $objname = $1;
     my $obj;
      $obj = LoadObjectByName ($objname); # load object to memory
      if (! defined ($obj)) { croak "Can't load object: $objname \n" }
      $obj->Draw ($from, $to,'',$paramline); #draw obj graph
      undef $obj;
};

$Tags {'CUSTOM_MENU'} = sub {
 my %pages;
 my @custompages;
 get_page_index (\%pages); #load all pages names
 foreach my $pagename (keys %pages) {
  push (@custompages, $pagename) if ($pagename =~ /^page\d+$/); #find all custom pages
 }
 if (@custompages) {
  foreach my $pagename (@custompages) {
   print ("<A HREF=\"",$Tags {'SCRIPT_URL' },"\?from=$from\&to=$to\&page=$pagename\">\n");
   print ("<IMG SRC=\"$Tags{'ICONS'}\/right.gif\" BORDER=0>$pages{$pagename}</A><BR>\n");
  }
 }
};

$Tags {'PAGE_NAME'} = sub {
 my %pages;
 get_page_index (\%pages); #load all pages names
 if (defined ($pages {$Page})) {
 print $pages {$Page}  #print current page name
 }
};


#generate HTML page from template
Gen (\%Tags,$DefaultTemplate,1);

